package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.playTimer;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams.Teams;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;

public class TicketingCommand extends ApplianceCommand<PlayTimer> {
    public TicketingCommand() {
        super("ticketing");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        sender.sendMessage(String.format("Ticketing was %b", this.getAppliance().isEnabled()));
        if(args.length < 1)
            throw new Error("Stop Ticketing with 'stop' or start ticketing (now subtracting one) and start team-countdown with 'start'");

        switch(args[0]) {
            case "stop" -> this.getAppliance().changeEnabled(false);
            case "start" -> {
                this.getAppliance().changeEnabled(true);
                Main.instance().getAppliance(Teams.class).getAllTeams().forEach(team -> {
                    boolean isAllowed = this.getAppliance().tryConsumeTicket(team);
                    if(!isAllowed) {
                        Main.logger().warning(String.format("Team %s already on Server, Ticketing got enabled but no Tickets were left! KICKING!", team.name));
                        team.kickTeam();
                    }

                    team.startCountDown();
                });
                sender.sendMessage(String.format("Ticketing (ticket reduction on join) is now %b", this.getAppliance().isEnabled()));
            }
            default -> sender.sendMessage("Unknown command");
        }

        sender.sendMessage(String.format("Ticketing is now %b", this.getAppliance().isEnabled()));
    }
}
