package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.strike;

import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;
import eu.mhsl.craftattack.spawn.core.Main;
import org.bukkit.Bukkit;

import java.io.IOException;
import java.io.Reader;
import java.io.Writer;
import java.lang.reflect.Type;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;

public class InvClear {
    private static final Path saveFile = Paths.get(Main.instance().getDataFolder().getAbsolutePath(), "invClear.json");
    private static final List<UUID> players = new ArrayList<>();

    static {
        load();
    }

    public static void add(UUID player) {
        Main.logger().info(String.format("Cannot clear inv because Player is offline. Remembering %s", player));
        players.add(player);
        Bukkit.getScheduler().runTaskAsynchronously(Main.instance(), InvClear::save);
    }

    public static boolean contains(UUID player) {
        return players.contains(player);
    }

    public static void remove(UUID player) {
        players.remove(player);
        Bukkit.getScheduler().runTaskAsynchronously(Main.instance(), InvClear::save);
    }

    private static void load() {
        if (!Files.exists(saveFile)) return;
        try (Reader reader = Files.newBufferedReader(saveFile)) {
            Type type = new TypeToken<List<UUID>>() {}.getType();
            List<UUID> loaded = new Gson().fromJson(reader, type);
            if (loaded != null) {
                players.clear();
                players.addAll(loaded);
            }
        } catch (IOException e) {
            Main.logger().warning("Failed to load InvClear data: " + e.getMessage());
        }
    }

    private static void save() {
        try {
            Files.createDirectories(saveFile.getParent());
            try (Writer writer = Files.newBufferedWriter(saveFile)) {
                new Gson().toJson(players, writer);
            }
        } catch (IOException e) {
            Main.logger().warning("Failed to save InvClear data: " + e.getMessage());
        }
    }
}
